
//|
//| Modified from ADR_SL-NoLine.mq4 by Terry Nicholls
//| Modified by Alfonso Moreno
//+------------------------------------------------------------------+
#property copyright "www.forextradingcoaches.com"
#property link      "www.forextradingcoaches.com"

#property indicator_chart_window
#property indicator_minimum	0
#property indicator_maximum	1

bool isStarting;

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                ADR_SL-NoLine.mq4 |
//|                                       Copyright  Terry Nicholls |
//| Some code modified from TSR_Ranges.mq4 by Ogeima                 |
//| made for FXiGoR for the TSR Trend Slope Retracement method       |
//| modified to the DYNAMIC Daily Range Breakout System              |
//+------------------------------------------------------------------+

/* This will display the Average Daily Range (pip movement)
   for Yesterday, Today, and 5, 10, and 20 day periods.
   Below that will display the number of pips for a Stop Loss based on 1/2 and 3/4
   of the ADR. */


//extern double  Risk_to_Reward_ratio =  3.0;
extern string currency="";

bool Show0D    = true;
extern bool Show1D    = true;
extern bool Show5D    = true;
extern bool Show10D   = true;
extern bool Show20D   = true;
bool ShowMid   = false;

extern string fontName="Arial";
extern int fontSize=7;
extern color labelColor=White;
extern color valueColor=Lime;
extern int horizDistance=0;
extern int vertDistance=30;
extern int spaceToNextValue=30;
extern int spaceToNextLabel=8;
extern int nextLineDistance=15;
extern int spaceToSeparator=20;

extern color MediumColor=Yellow;
extern color HighColor=Red;
extern color LowColor=Lime;

extern double HighPercent = 91;
extern double LowPercent  = 75;

int nDigits;
double today_high=0;
double today_low=0;
double D=0;
double nD=0;
double nhR1=0;
double nqR1=0;
double nhR5=0;
double nqR5=0;
double nhR10=0;
double nqR10=0;
double nhR20=0;
double nqR20=0;
double rates_d1[2][6];

int nWindow;

#import "ftc_EALib.ex4"
	bool goodToGo();
	string 	getAccountType();
#import
bool okToRun=false;
string short_name;
int counted_bars;

string declaredCurrency;
double currencyPoint;

double fractionalPipTickFactor;
double fractionalPipValueFactor;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
  isStarting=true;
  //Print("init");
	//deleteObjects();
	string indicatorName;
	
	HighPercent = HighPercent * 0.01;
	LowPercent  = LowPercent * 0.01;
	
	declaredCurrency=currency;
	
	int iDigits;
	iDigits=MarketInfo(Symbol(),MODE_DIGITS);
	//Print("Digits: ",iDigits);
	
	if(iDigits==3 || iDigits==5) 
		{
		fractionalPipTickFactor=0.1;
		fractionalPipValueFactor=10;
		}
	else 
		{
		fractionalPipTickFactor=1.0;
		fractionalPipValueFactor=1.0;
		}	
	
	if(currency!="") 
		{
		indicatorName=StringConcatenate(declaredCurrency," ADR:");
		horizDistance=horizDistance;
		}
	else indicatorName="FTC ADR:";
	
   IndicatorShortName(indicatorName);
   
   nWindow=0;
   
	string cAccountType;
	cAccountType=getAccountType();
	// set up the proper name for the currencies if running a mini account
	if(currency!="")
		{
		if(cAccountType=="MINI")
			{
			if(currency!="") declaredCurrency=StringConcatenate(StringSubstr(currency,0,6),StringSubstr(Symbol(),6,0));
			}
		}
	else declaredCurrency=Symbol();
	
	currencyPoint=MarketInfo(declaredCurrency,MODE_POINT);
	//currencyPoint=MarketInfo(declaredCurrency,MODE_POINT)*fractionalPipTickFactor;
	//Print("CurrencyPoint: ",currencyPoint);
	
   //Print("Window: ",nWindow);
   return(0);
   
  }

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void deleteObjects()
	{
	//Print("Deleting Objects");
   ObjectDelete(StringConcatenate("ftcADR1_",nWindow));
   ObjectDelete(StringConcatenate("ftcADR2_",nWindow));
   ObjectDelete(StringConcatenate("ftcADR3_",nWindow));
   ObjectDelete(StringConcatenate("ftcADR4_",nWindow));
   ObjectDelete(StringConcatenate("ftcADR5_",nWindow));
   ObjectDelete(StringConcatenate("ftcADR6_",nWindow));
   ObjectDelete(StringConcatenate("ftcADR7_",nWindow));
   ObjectDelete(StringConcatenate("ftcADR8_",nWindow));
   ObjectDelete(StringConcatenate("ftcADR9_",nWindow));
   ObjectDelete(StringConcatenate("ftcADR10_",nWindow));
   ObjectDelete(StringConcatenate("ftcADR11_",nWindow));
   ObjectDelete(StringConcatenate("ftcADR12_",nWindow));
   ObjectDelete(StringConcatenate("ftcADR_CURRENCY_",nWindow));
   
   string obj_name;
   
   for(int i = 0; i < ObjectsTotal(); i++)
   {
      obj_name = ObjectName(i);
      
      if(StringFind(obj_name, "ftcADR") != -1)
      {
         ObjectDelete(obj_name);
      }
	}
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
  {
  //Print("deinit");
  deleteObjects();
/*
   ObjectDelete("ftcADR13");
   ObjectDelete("ftcADR14");
   ObjectDelete("ftcADR15");
   ObjectDelete("ftcADR16");
   ObjectDelete("ftcADR17");
   ObjectDelete("ftcADR18");
   ObjectDelete("ftcADR19");
   ObjectDelete("ftcADR20");
   ObjectDelete("ftcADR21");
   ObjectDelete("ftcADR22");
   ObjectDelete("ftcADR23");
   ObjectDelete("ftcADR24");
   ObjectDelete("ftcADR25");
   ObjectDelete("ftcADR26");
   ObjectDelete("ftcADR27");
*/
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {
	static int expireAlertCount=0;
	static bool priorValidPass=false;
   	
	if(AccountNumber()==0) 
		{
		Comment("");
		return(false);
		}
	
	if(!isStarting && IndicatorCounted()<Bars-1) return(0);
	
	okToRun=goodToGo();
	
	if(okToRun==false)
		{
		if(expireAlertCount==0) Alert(declaredCurrency,",",Period()," ftc_ADR License not present or expired");
		expireAlertCount++;
		priorValidPass=false;
		deinit();
		return(false);
		}
		
  	if(!priorValidPass) 
  		{
  		counted_bars=0;
  		deleteObjects();
  		priorValidPass=true;
  		expireAlertCount=0;
  		}
  	else counted_bars=IndicatorCounted();
	
	
	int xDistance=horizDistance, yDistance=vertDistance;

	//Print("Start");
	
	//Print("Time[0]: ",TimeToStr(Time[0],TIME_DATE|TIME_MINUTES|TIME_SECONDS),", TimeCurrent: ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS));
	
	if(Time[0]<TimeCurrent()-(Period()*60)) 
		{
		//Print("Returning Early");
		return(0);
		}
	
//	deleteObjects();
	datetime daytimes[];
	ArrayCopyRates(rates_d1, declaredCurrency, PERIOD_D1);   //---- Get new daily prices
	int error=GetLastError();
	//Print("Last Error: ",error);
	if(error==4066)
  	{
   	//---- make two more attempts to read
   	for(int xCount=0;xCount<5; xCount++)
     		{
   		Sleep(1000);
  			ArrayCopyRates(rates_d1, declaredCurrency, PERIOD_D1);   //---- Get new daily prices
   		//---- check the current daily bar time
   		datetime last_day=rates_d1[0][0];
   		if(Year()==TimeYear(last_day) && Month()==TimeMonth(last_day) && Day()==TimeDay(last_day)) break;
     		}
	  	//Print("xCount: ",xCount);
  	}
	
	
//   if(counted_bars>0) counted_bars--;
//	if(counted_bars<Bars-1) return(0);
	
	
   int R1=0,R5=0,R10=0,R20=0,RAvg=0;
   int RoomUp=0,RoomDown=0;  // ,StopLoss_Long=0,StopLoss_Short=0;
   //double   SL_Long=0,SL_Short=0;
   double   low0=0,high0=0;
   string   Text="";
   int i=0;

	today_high = rates_d1[0][3];
	today_low = rates_d1[0][2];

	D = (today_high - today_low);

   R1 =  (iHigh(declaredCurrency,PERIOD_D1,1)-iLow(declaredCurrency,PERIOD_D1,1))/currencyPoint;
   for(i=1;i<=5;i++)
      R5    =    R5  +  (iHigh(declaredCurrency,PERIOD_D1,i)-iLow(declaredCurrency,PERIOD_D1,i))/currencyPoint;
   for(i=1;i<=10;i++)
      R10   =    R10 +  (iHigh(declaredCurrency,PERIOD_D1,i)-iLow(declaredCurrency,PERIOD_D1,i))/currencyPoint;
   for(i=1;i<=20;i++)
      R20   =    R20 +  (iHigh(declaredCurrency,PERIOD_D1,i)-iLow(declaredCurrency,PERIOD_D1,i))/currencyPoint;

   R5 = R5/5;
   R10 = R10/10;
   R20 = R20/20;
   RAvg  =  (R1+R5+R10+R20)/4;    

   low0  =  iLow(declaredCurrency,PERIOD_D1,0);
   high0 =  iHigh(declaredCurrency,PERIOD_D1,0);
   RoomUp   =  RAvg - (Bid - low0)/currencyPoint;
   RoomDown =  RAvg - (high0 - Bid)/currencyPoint;
   //StopLoss_Long  =  RoomUp/Risk_to_Reward_ratio;
   //SL_Long        =  Bid - nhR1*currencyPoint;
   //StopLoss_Short =  RoomDown/Risk_to_Reward_ratio;
   //SL_Short       =  Bid + nhR1*currencyPoint;

//	if (D > 1)
//	{
//		nD = D;
//	}
//	else
//	{
//	nD = D*10000;
		nD = D/currencyPoint;
//	}

	if (R1 > 1)
	{
		nhR1 = R1/2;
	}
	else
	{
		nhR1 = 0;
	}

	if (R1 > 1)
	{
		nqR1 = R1*0.75;
	}
	else
	{
		nqR1 = 0;
	}

	if (R5 > 1)
	{
		nhR5 = R5/2;
	}
	else
	{
		nhR5 = 0;
	}

	if (R5 > 1)
	{
		nqR5 = R5*0.75;
	}
	else
	{
		nqR5 = 0;
	}

	if (R10 > 1)
	{
		nhR10 = R10/2;
	}
	else
	{
		nhR10 = 0;
	}

	if (R10 > 1)
	{
		nqR10 = R10*0.75;
	}
	else
	{
		nqR20 = 0;
	}

	if (R20 > 1)
	{
		nhR20 = R20/2;
	}
	else
	{
		nhR20 = 0;
	}

	if (R20 > 1)
	{
		nqR20 = R20*0.75;
	}
	else
	{
		nqR20 = 0;
	}

	// Displays Average Daily Range for Today, Yesterday, 5 Days, 10 Days, and 20 Days
	deleteObjects();
	
	double pcntToday;
	pcntToday=nD/((R10+R20)/2);
	
	if(pcntToday >= LowPercent && pcntToday <= HighPercent)
	{
	    valueColor = MediumColor;  
	}
	else if(pcntToday > HighPercent)
	{
	    valueColor = HighColor;  
	}
	else if(pcntToday < LowPercent)
	{
	    valueColor = LowColor;  
	}
	
	int last_width;
	
	ObjectCreate(StringConcatenate("ftcADR0_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	ObjectSetText(StringConcatenate("ftcADR0_",nWindow),"  ADR: ", fontSize, fontName, labelColor);
	ObjectSet(StringConcatenate("ftcADR0_",nWindow), OBJPROP_CORNER, 0);
	ObjectSet(StringConcatenate("ftcADR0_",nWindow), OBJPROP_XDISTANCE, xDistance);
	ObjectSet(StringConcatenate("ftcADR0_",nWindow), OBJPROP_YDISTANCE, yDistance);
	
	last_width = ObjectGet("ftcADR0_", OBJPROP_XDISTANCE);
	
	xDistance=xDistance+spaceToNextValue+last_width;
	ObjectCreate(StringConcatenate("ftcADR_CURRENCY_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	ObjectSetText(StringConcatenate("ftcADR_CURRENCY_",nWindow),StringConcatenate(DoubleToStr(pcntToday*100,1),"%"), fontSize, fontName, valueColor);
	ObjectSet(StringConcatenate("ftcADR_CURRENCY_",nWindow), OBJPROP_CORNER, 0);
	ObjectSet(StringConcatenate("ftcADR_CURRENCY_",nWindow), OBJPROP_XDISTANCE, xDistance);
	ObjectSet(StringConcatenate("ftcADR_CURRENCY_",nWindow), OBJPROP_YDISTANCE, yDistance);
	
	//Print("Creating Objects...");
	// TODAY
	if(Show0D)
	{
	  last_width = ObjectGet("ftcADR_CURRENCY_", OBJPROP_XDISTANCE);
	
	  xDistance=xDistance+spaceToSeparator+last_width+20;
	
	  ObjectCreate(StringConcatenate("ftcADR1_separator",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR1_separator",nWindow),"|", fontSize, fontName, labelColor);
	  ObjectSet(StringConcatenate("ftcADR1_separator",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR1_separator",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR1_separator",nWindow), OBJPROP_YDISTANCE, yDistance);
		
	  last_width = ObjectGet("ftcADR1_separator", OBJPROP_XDISTANCE);
	
	  xDistance=xDistance+spaceToNextLabel+last_width;
	
	  ObjectCreate(StringConcatenate("ftcADR1_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR1_",nWindow),"Today: ", fontSize, fontName, labelColor);
	  ObjectSet(StringConcatenate("ftcADR1_",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR1_",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR1_",nWindow), OBJPROP_YDISTANCE, yDistance);
	
	  pcntToday=nD*fractionalPipTickFactor/((R10+R20)/2);
	
	  if(pcntToday >= LowPercent && pcntToday <= HighPercent)
	  {
	      valueColor = MediumColor;  
	  }
	  else if(pcntToday > HighPercent)
	  {
	      valueColor = HighColor;  
	  }
	  else if(pcntToday < LowPercent)
	  {
	      valueColor = LowColor;  
	  }
	
	  last_width = ObjectGet("ftcADR1_", OBJPROP_XDISTANCE);
	
	  xDistance=xDistance+spaceToNextValue+last_width;
	  ObjectCreate(StringConcatenate("ftcADR2_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR2_",nWindow),DoubleToStr(nD*fractionalPipTickFactor,0),fontSize, fontName, valueColor);
	  ObjectSet(StringConcatenate("ftcADR2_",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR2_",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR2_",nWindow), OBJPROP_YDISTANCE, yDistance);
	  
	  last_width = ObjectGet("ftcADR2_", OBJPROP_XDISTANCE);
	}
	
	if(Show1D)
	{
	  xDistance=xDistance+spaceToSeparator+last_width;	
	  ObjectCreate(StringConcatenate("ftcADR2_separator",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR2_separator",nWindow),"|", fontSize, fontName, labelColor);
	  ObjectSet(StringConcatenate("ftcADR2_separator",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR2_separator",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR2_separator",nWindow), OBJPROP_YDISTANCE, yDistance);
	
	  last_width = ObjectGet("ftcADR2_separator", OBJPROP_XDISTANCE);
	
	  // 1 DAY
	  xDistance=xDistance+spaceToNextLabel+last_width;
	  ObjectCreate(StringConcatenate("ftcADR3_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR3_",nWindow),"1 Day: ", fontSize, fontName, labelColor);
	  ObjectSet(StringConcatenate("ftcADR3_",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR3_",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR3_",nWindow), OBJPROP_YDISTANCE, yDistance);
	
	  pcntToday=R1*fractionalPipTickFactor/((R10+R20)/2);
	
	  if(pcntToday >= LowPercent && pcntToday <= HighPercent)
	  {
	      valueColor = MediumColor;  
	  }
	  else if(pcntToday > HighPercent)
	  {
	      valueColor = HighColor;  
	  }
	  else if(pcntToday < LowPercent)
	  {
	      valueColor = LowColor;  
	  }
	
	  last_width = ObjectGet("ftcADR3_", OBJPROP_XDISTANCE);

	  xDistance=xDistance+spaceToNextValue+last_width;
	  ObjectCreate(StringConcatenate("ftcADR4_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR4_",nWindow),DoubleToStr(R1*fractionalPipTickFactor,0),fontSize, fontName, valueColor);
	  ObjectSet(StringConcatenate("ftcADR4_",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR4_",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR4_",nWindow), OBJPROP_YDISTANCE, yDistance);
	  
	  last_width = ObjectGet("ftcADR4_", OBJPROP_XDISTANCE);
   }	
	// 10/20 mid
	
	if(Show5D)
	{
	  xDistance=xDistance+spaceToSeparator+last_width;	
	  ObjectCreate(StringConcatenate("ftcADR4_separator",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR4_separator",nWindow),"|", fontSize, fontName, labelColor);
	  ObjectSet(StringConcatenate("ftcADR4_separator",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR4_separator",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR4_separator",nWindow), OBJPROP_YDISTANCE, yDistance);
	
	  last_width = ObjectGet("ftcADR4_separator", OBJPROP_XDISTANCE);
	  // 5 DAY
	  xDistance=xDistance+spaceToNextLabel+last_width;
	  ObjectCreate(StringConcatenate("ftcADR5_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR5_",nWindow),"5 Day: ", fontSize, fontName, labelColor);
	  ObjectSet(StringConcatenate("ftcADR5_",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR5_",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR5_",nWindow), OBJPROP_YDISTANCE, yDistance);
	
	  pcntToday=R5*fractionalPipTickFactor*fractionalPipTickFactor/((R10+R20)/2);
	
	  if(pcntToday >= LowPercent && pcntToday <= HighPercent)
	  {
	      valueColor = MediumColor;  
	  }
	  else if(pcntToday > HighPercent)
	  {
	      valueColor = HighColor;  
	  }
	  else if(pcntToday < LowPercent)
	  {
	      valueColor = LowColor;  
	  }
	
	  last_width = ObjectGet("ftcADR5_", OBJPROP_XDISTANCE);

	  xDistance=xDistance+spaceToNextValue+last_width;
	  ObjectCreate(StringConcatenate("ftcADR6_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR6_",nWindow),DoubleToStr(R5*fractionalPipTickFactor ,0),fontSize, fontName, valueColor);
	  ObjectSet(StringConcatenate("ftcADR6_",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR6_",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR6_",nWindow), OBJPROP_YDISTANCE, yDistance);
	  
	  last_width = ObjectGet("ftcADR6_", OBJPROP_XDISTANCE);
	}
	
	if(Show10D)
	{
	  // 10 DAY
	  //xDistance=xDistance+spaceToNextLabel;
	  xDistance=xDistance+spaceToSeparator+last_width;	
	  ObjectCreate(StringConcatenate("ftcADR10_separator",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR10_separator",nWindow),"|", fontSize, fontName, labelColor);
	  ObjectSet(StringConcatenate("ftcADR10_separator",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR10_separator",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR10_separator",nWindow), OBJPROP_YDISTANCE, yDistance);
	  
	  last_width = ObjectGet("ftcADR10_separator", OBJPROP_XDISTANCE);
	  
	  xDistance=xDistance+spaceToNextLabel+last_width;
	  
	  ObjectCreate(StringConcatenate("ftcADR7_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR7_",nWindow),"10 Day: ", fontSize, fontName, labelColor);
	  ObjectSet(StringConcatenate("ftcADR7_",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR7_",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR7_",nWindow), OBJPROP_YDISTANCE, yDistance);
	  
	  pcntToday=R10*fractionalPipTickFactor/((R10+R20)/2);
	
	  if(pcntToday >= LowPercent && pcntToday <= HighPercent)
	  {
	      valueColor = MediumColor;  
	  }
	  else if(pcntToday > HighPercent)
	  {
	      valueColor = HighColor;  
	  }
	  else if(pcntToday < LowPercent)
	  {
	      valueColor = LowColor;  
	  }

	  xDistance=xDistance+spaceToNextValue+(spaceToNextValue/5);
	  ObjectCreate(StringConcatenate("ftcADR8_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR8_",nWindow),DoubleToStr(R10*fractionalPipTickFactor ,0),fontSize, fontName, valueColor);
	  ObjectSet(StringConcatenate("ftcADR8_",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR8_",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR8_",nWindow), OBJPROP_YDISTANCE, yDistance);
	
	  last_width = ObjectGet("ftcADR8_", OBJPROP_XDISTANCE);
	}
	
	if(Show20D)
	{
	  xDistance=xDistance+spaceToSeparator+last_width;	
	  ObjectCreate(StringConcatenate("ftcADR20_separator",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR20_separator",nWindow),"|", fontSize, fontName, labelColor);
	  ObjectSet(StringConcatenate("ftcADR20_separator",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR20_separator",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR20_separator",nWindow), OBJPROP_YDISTANCE, yDistance);
	  
	  last_width = ObjectGet("ftcADR20_separator", OBJPROP_XDISTANCE);
	  
	  xDistance=xDistance+spaceToNextLabel+last_width;
	  
	  xDistance=xDistance+spaceToNextLabel;
	  ObjectCreate(StringConcatenate("ftcADR9_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR9_",nWindow),"20 Day: ", fontSize, fontName, labelColor);
	  ObjectSet(StringConcatenate("ftcADR9_",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR9_",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR9_",nWindow), OBJPROP_YDISTANCE, yDistance);
	  
	  pcntToday=R20*fractionalPipTickFactor/((R10+R20)/2);
	
	  if(pcntToday >= LowPercent && pcntToday <= HighPercent)
	  {
	      valueColor = MediumColor;  
	  }
	  else if(pcntToday > HighPercent)
	  {
	      valueColor = HighColor;  
	  }
	  else if(pcntToday < LowPercent)
	  {
	      valueColor = LowColor;  
	  }

	  xDistance=xDistance+spaceToNextValue+(spaceToNextValue/5);
	  ObjectCreate(StringConcatenate("ftcADR10_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR10_",nWindow),DoubleToStr(R20*fractionalPipTickFactor ,0),fontSize, fontName, valueColor);
	  ObjectSet(StringConcatenate("ftcADR10_",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR10_",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR10_",nWindow), OBJPROP_YDISTANCE, yDistance);
	  
	  last_width = ObjectGet("ftcADR10_", OBJPROP_XDISTANCE);
	}
	
	if(ShowMid)
	{
	    xDistance=xDistance+spaceToSeparator+last_width;	
	  ObjectCreate(StringConcatenate("ftcADR3_separator",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR3_separator",nWindow),"|", fontSize, fontName, labelColor);
	  ObjectSet(StringConcatenate("ftcADR3_separator",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR3_separator",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR3_separator",nWindow), OBJPROP_YDISTANCE, yDistance);
	
	  last_width = ObjectGet("ftcADR3_separator", OBJPROP_XDISTANCE);
	
	  xDistance=xDistance+spaceToNextLabel+last_width;
	  ObjectCreate(StringConcatenate("ftcADR11_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR11_",nWindow),"10/20: ", fontSize, fontName, labelColor);
	  ObjectSet(StringConcatenate("ftcADR11_",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR11_",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR11_",nWindow), OBJPROP_YDISTANCE, yDistance);
	
	  pcntToday=((R10+R20)/2)*fractionalPipTickFactor/((R10+R20)/2);
	
	  if(pcntToday >= LowPercent && pcntToday <= HighPercent)
	  {
	      valueColor = MediumColor;  
	  }
	  else if(pcntToday > HighPercent)
	  {
	      valueColor = HighColor;  
	  }
	  else if(pcntToday < LowPercent)
	  {
	      valueColor = LowColor;  
	  }
	
	  last_width = ObjectGet("ftcADR11_", OBJPROP_XDISTANCE);
	
	  xDistance=xDistance+spaceToNextValue+last_width;
	  ObjectCreate(StringConcatenate("ftcADR12_",nWindow), OBJ_LABEL, nWindow, 0, 0);
	  ObjectSetText(StringConcatenate("ftcADR12_",nWindow),DoubleToStr(((R10+R20)/2)*fractionalPipTickFactor ,0),fontSize, fontName, valueColor);
	  ObjectSet(StringConcatenate("ftcADR12_",nWindow), OBJPROP_CORNER, 0);
	  ObjectSet(StringConcatenate("ftcADR12_",nWindow), OBJPROP_XDISTANCE, xDistance);
	  ObjectSet(StringConcatenate("ftcADR12_",nWindow), OBJPROP_YDISTANCE, yDistance);
	}
	
	isStarting=false;
   return(0);
  }

//+------------------------------------------------------------------+