//+------------------------------------------------------------------+
//|                                     csb_SupportAndResistance.mq4 |
//|                       Christian Berrigan, Wade Scott, Steve Cook |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Christian Berrigan, Wade Scott, Steve Cook"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_width1 3
#property indicator_width2 3


//extern int dayPeriodEndHour=4;
extern int	fromHour_EST=00;		// the EST hour of the time that you want 24 hour period separators drawn
extern string forcePeriodToGet=" ";
string periodToGet=" ";

double pphigh, pplow, ppopen, ppclose;

//---- buffers
double priorHigh[];
double priorLow[];

#import "ftc_EALib.ex4"
	bool goodToGo();
	string isStandardOrDaylight(string whichZone, datetime dTime);
#import
bool okToRun=false;

int dayPeriodEndHour;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
	
	// modify the fromHour_EST by the GMTOffset
	int GMTOffset, brokerHoursFromEST;
   if(GlobalVariableCheck("ftc_BrokerGMTOffset"))
   	{
   	GMTOffset=GlobalVariableGet("ftc_BrokerGMTOffset");
   	}
   else GMTOffset=0;
   
   if(GMTOffset>0) GMTOffset=GMTOffset-24;
   
   brokerHoursFromEST=5-GMTOffset;
   if(brokerHoursFromEST>23) brokerHoursFromEST=brokerHoursFromEST-24;
	dayPeriodEndHour=fromHour_EST+brokerHoursFromEST;
	if(dayPeriodEndHour>23) dayPeriodEndHour=dayPeriodEndHour-24;
	if(dayPeriodEndHour<0) dayPeriodEndHour=dayPeriodEndHour+24;
	
//---- indicators
   IndicatorDigits(Digits);

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,158);
   SetIndexBuffer(0,priorHigh);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,158);
   SetIndexBuffer(1,priorLow);

	if(forcePeriodToGet==" ")
		{
//		if(Period()<PERIOD_H4) periodToGet="D";
		
		if(Period()<=PERIOD_H4) periodToGet="W";
		
		if(Period()>PERIOD_H4) periodToGet="M";
		
		if(Period()==PERIOD_MN1) periodToGet=" ";
		
		}
	else periodToGet=forcePeriodToGet;
		
	if(periodToGet=="D")
		{ 
//SetIndexArrow(0,158);
//SetIndexArrow(1,158);
		SetIndexLabel(0,StringConcatenate("Yesterday's High(",periodToGet,")"));
		SetIndexLabel(1,StringConcatenate("Yesterday's Low(",periodToGet,")"));
		}
	if(periodToGet=="W")
		{ 
//SetIndexArrow(0,159);
//SetIndexArrow(1,159);
		SetIndexLabel(0,StringConcatenate("Last Week's High(",periodToGet,")"));
		SetIndexLabel(1,StringConcatenate("Last Week's Low(",periodToGet,")"));
		}
	if(periodToGet=="M")
		{ 
//SetIndexArrow(0,170);
//SetIndexArrow(1,170);
		SetIndexLabel(0,StringConcatenate("Last Month's High(",periodToGet,")"));
		SetIndexLabel(1,StringConcatenate("Last Month's Low(",periodToGet,")"));
		}
	if((periodToGet!="D" && periodToGet!="W" && periodToGet!="M") || periodToGet==" ")
		{
		SetIndexLabel(0," ");
		SetIndexLabel(1," ");
		SetIndexEmptyValue(0,0.0);
		SetIndexEmptyValue(1,0.0);
		}
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
	ArrayInitialize(priorHigh,0);
	ArrayInitialize(priorLow,0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
	int   iCurBar, limit, i;
   int   counted_bars;
	
	
	static int expireAlertCount=0;
	static bool priorValidPass=false;
   	
	if(AccountNumber()==0) 
		{
		Comment("");
		return(false);
		}
	
	okToRun=goodToGo();
	if(okToRun==false)
		{
		if(expireAlertCount==0) Alert(Symbol(),",",Period()," ftc_SupportAndResistance License not present or expired");
		expireAlertCount++;
		priorValidPass=false;
		deinit();
		return(false);
		}
		
  	if(!priorValidPass) 
  		{
  		counted_bars=0;
  		priorValidPass=true;
  		expireAlertCount=0;
  		}
  	else counted_bars=IndicatorCounted();
	
	if((periodToGet!="D" && periodToGet!="W" && periodToGet!="M") || periodToGet==" ") return(0);
	
//----
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   
   for(iCurBar=limit; iCurBar>=0; iCurBar--)
      {  
		GetHLC(periodToGet, dayPeriodEndHour, iCurBar);
		priorHigh[iCurBar]=pphigh;
		priorLow[iCurBar]=pplow;
		//Print("pphigh: ",DoubleToStr(pphigh,4),", pplow: ",DoubleToStr(pplow,4));
		}
//----
   
//----
	//Print("Start Finished");
   return(0);
  }
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
void GetHLC(string periodToGet, int dayPeriodEndHour, int shift)
   {
   	
   	//Print("periodToGet: ",periodToGet,", dayPeriodEndHour: ",dayPeriodEndHour,", shift: ",shift);
   	
		datetime curChartBarTime;
		curChartBarTime=iTime(NULL,0,shift);
		
      if(periodToGet=="D")
         {
         // first figure out the starting and ending points for Highest() and Lowest() functions
         //-- the number of bars this chart has in a 24 hour Period
         //int numberofbars=PERIOD_D1/Period();
         int numberofbars=24;  //-- one day of hours
         numberofbars=numberofbars-1;
			
			// get the shift of the hourly chart for the time of this bar in the current chart
			
			int curHourChartBar;
			//curHourChartBar=iBarShift(NULL,PERIOD_H1,curChartBarTime,false);
			if(isStandardOrDaylight("US", curChartBarTime)=="DAYLIGHT")
				{
				curHourChartBar=iBarShift(NULL,PERIOD_H1,curChartBarTime,false)-1;
				}
			if(isStandardOrDaylight("US", curChartBarTime)=="STANDARD")
				{
				curHourChartBar=iBarShift(NULL,PERIOD_H1,curChartBarTime,false);
				}
			
         int endbar=0;
         
         int limit=iBars(NULL,PERIOD_H1);

         for(int i=curHourChartBar; i<=limit; i++)
         	{
         	int bartime=iTime(NULL,PERIOD_H1,i);

         	if (TimeHour(bartime)==dayPeriodEndHour)
            	{
            	endbar=i+1;
            	break;
            	}
         	}
         
         
         pphigh=iHigh(NULL,PERIOD_H1,Highest(NULL,PERIOD_H1,MODE_HIGH,numberofbars,endbar));
         pplow=iLow(NULL,PERIOD_H1,Lowest(NULL,PERIOD_H1,MODE_LOW,numberofbars,endbar));
         ppclose=iClose(NULL,PERIOD_H1,endbar);
         ppopen=iOpen(NULL,PERIOD_H1,endbar);
         
         //Print("High: ",pphigh," Low: ",pplow," Close: ",ppclose);
         }
         
      if(periodToGet=="W")
         {
         // get the HLC from the prior weekly candle
         int curWeekChartBar;
         curWeekChartBar=iBarShift(NULL,PERIOD_W1,curChartBarTime,false);
         pphigh=iHigh(NULL,PERIOD_W1,curWeekChartBar+1);
         pplow=iLow(NULL,PERIOD_W1,curWeekChartBar+1);
         ppclose=iClose(NULL,PERIOD_W1,curWeekChartBar+1);
         ppopen=iOpen(NULL,PERIOD_W1,curWeekChartBar+1);
         }
         
      if(periodToGet=="M")
         {
         int curMonthChartBar;
         curMonthChartBar=iBarShift(NULL,PERIOD_MN1,curChartBarTime,false);
         
         pphigh=iHigh(NULL,PERIOD_MN1,curMonthChartBar+1);
         pplow=iLow(NULL,PERIOD_MN1,curMonthChartBar+1);
         ppclose=iClose(NULL,PERIOD_MN1,curMonthChartBar+1);
         ppopen=iOpen(NULL,PERIOD_MN1,curMonthChartBar+1);
         }
	}